scala.tools.nsc.transform.patmat.Solving

# Solver

###
Related Doc: package Solving

#### trait Solver extends CNF

Source
  Solving.scala

Linear Supertypes
CNF, Solving.PropositionalLogic, AnyRef, Any
Known Subclasses
OptimizingMatchTranslator
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Solver
2. CNF
3. PropositionalLogic
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait AbsVar extends AnyRef

   Definition Classes
     PropositionalLogic

2. #### class AlreadyInCNF extends AnyRef

   Definition Classes
     CNF

3. #### final case class And(ops: Set[Prop]) extends Prop with Product with Serializable

   Definition Classes
     PropositionalLogic

4. #### type Clause = Set[Lit]

   Definition Classes
     CNF

5. #### type Cnf = Array[Clause]

   Conjunctive normal form (of a Boolean formula).

   Conjunctive normal form (of a Boolean formula). A formula in this form is amenable to a SAT solver (i.e., solver that decides satisfiability of a formula).

   Definition Classes
     CNF

6. #### trait CnfBuilder extends AnyRef

   Definition Classes
     CNF

7. #### abstract type Const

   Definition Classes
     PropositionalLogic

8. #### final case class Eq(p: Var, q: Const) extends Prop with Product with Serializable

   Definition Classes
     PropositionalLogic

9. #### type Model = Map[Sym, Boolean]

   Definition Classes
     PropositionalLogic

10. #### final case class Not(a: Prop) extends Prop with Product with Serializable

    Definition Classes
      PropositionalLogic

11. #### final case class Or(ops: Set[Prop]) extends Prop with Product with Serializable

    Definition Classes
      PropositionalLogic

12. #### class Prop extends AnyRef

    Definition Classes
      PropositionalLogic

13. #### trait PropMap extends AnyRef

    Definition Classes
      PropositionalLogic

14. #### trait PropTraverser extends AnyRef

    Definition Classes
      PropositionalLogic

15. #### final case class Solution(model: Model, unassigned: List[Sym]) extends Product with Serializable

    Definition Classes
      PropositionalLogic

16. #### case class Solvable(cnf: Cnf, symbolMapping: SymbolMapping) extends Product with Serializable

    Definition Classes
      CNF

17. #### final class Sym extends Prop

    Definition Classes
      PropositionalLogic

18. #### class SymbolMapping extends AnyRef

    Definition Classes
      CNF

19. #### class TransformToCnf extends CnfBuilder

    Plaisted transformation: used for conversion of a propositional formula into conjunctive normal form (CNF) (input format for SAT solver).

    Plaisted transformation: used for conversion of a propositional formula into conjunctive normal form (CNF) (input format for SAT solver). A simple conversion into CNF via Shannon expansion would also be possible but it's worst-case complexity is exponential (in the number of variables) and thus even simple problems could become untractable. The Plaisted transformation results in an _equisatisfiable_ CNF-formula (it generates auxiliary variables) but runs with linear complexity. The common known Tseitin transformation uses bi-implication, whereas the Plaisted transformation uses implication only, thus the resulting CNF formula has (on average) only half of the clauses of a Tseitin transformation. The Plaisted transformation uses the polarities of sub-expressions to figure out which part of the bi-implication can be omitted. However, if all sub-expressions have positive polarity (e.g., after transformation into negation normal form) then the conversion is rather simple and the pseudo-normalization via NNF increases chances only one side of the bi-implication is needed.

    Definition Classes
      CNF

20. #### abstract type Tree

    Definition Classes
      PropositionalLogic

21. #### type TseitinModel = Set[Lit]

22. #### abstract type Type

    Definition Classes
      PropositionalLogic

23. #### abstract type TypeConst <: Const

    Definition Classes
      PropositionalLogic

24. #### trait TypeConstExtractor extends AnyRef

    Definition Classes
      PropositionalLogic

25. #### abstract type ValueConst <: Const

    Definition Classes
      PropositionalLogic

26. #### trait ValueConstExtractor extends AnyRef

    Definition Classes
      PropositionalLogic

27. #### abstract type Var <: AbsVar

    Definition Classes
      PropositionalLogic

28. #### trait VarExtractor extends AnyRef

    Definition Classes
      PropositionalLogic

### Abstract Value Members

1. #### abstract val NullConst: Const

   Definition Classes
     PropositionalLogic

2. #### abstract def TypeConst: TypeConstExtractor

   Definition Classes
     PropositionalLogic

3. #### abstract def ValueConst: ValueConstExtractor

   Definition Classes
     PropositionalLogic

4. #### abstract val Var: VarExtractor

   Definition Classes
     PropositionalLogic

5. #### abstract def prepareNewAnalysis(): Unit

   Definition Classes
     PropositionalLogic

6. #### abstract def reportWarning(message: String): Unit

   Definition Classes
     PropositionalLogic

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Solver to any2stringadd[Solver] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Solver, B)

   Implicit information
     This member is added by an implicit conversion from Solver to ArrowAssoc[Solver] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### def /\(props: Iterable[Prop]): Serializable with Product with Prop

   Definition Classes
     PropositionalLogic

6. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

7. #### object And extends Serializable

   Definition Classes
     PropositionalLogic

8. #### val EmptyModel: Map[Sym, Boolean]

   Definition Classes
     Solver → PropositionalLogic

9. #### val EmptyTseitinModel: Set[Lit]

10. #### object False extends Prop with Product with Serializable

    Definition Classes
      PropositionalLogic

11. #### val NoModel: Model

    Definition Classes
      Solver → PropositionalLogic

12. #### val NoTseitinModel: TseitinModel

13. #### object Or extends Serializable

    Definition Classes
      PropositionalLogic

14. #### object Sym

    Definition Classes
      PropositionalLogic

15. #### object True extends Prop with Product with Serializable

    Definition Classes
      PropositionalLogic

16. #### def \/(props: Iterable[Prop]): Serializable with Product with Prop

    Definition Classes
      PropositionalLogic

17. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

18. #### val budgetProp: sys.Prop[String]

    Definition Classes
      PropositionalLogic

19. #### def clause(l: Lit*): Clause

    Definition Classes
      CNF

20. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

21. #### def cnfString(f: Array[Clause]): String

22. #### def ensuring(cond: (Solver) ⇒ Boolean, msg: ⇒ Any): Solver

    Implicit information
      This member is added by an implicit conversion from Solver to Ensuring[Solver] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

23. #### def ensuring(cond: (Solver) ⇒ Boolean): Solver

    Implicit information
      This member is added by an implicit conversion from Solver to Ensuring[Solver] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### def ensuring(cond: Boolean, msg: ⇒ Any): Solver

    Implicit information
      This member is added by an implicit conversion from Solver to Ensuring[Solver] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: Boolean): Solver

    Implicit information
      This member is added by an implicit conversion from Solver to Ensuring[Solver] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### def eqFreePropToSolvable(p: Prop): Solvable

    Definition Classes
      CNF → PropositionalLogic

28. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

29. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

30. #### def findAllModelsFor(solvable: Solvable): List[Solution]

    Definition Classes
      Solver → PropositionalLogic

31. #### def findModelFor(solvable: Solvable): Model

    Definition Classes
      Solver → PropositionalLogic

32. #### def findTseitinModelFor(clauses: Array[Clause]): TseitinModel

33. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Solver to StringFormat[Solver] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

34. #### def gatherSymbols(p: Prop): Set[Sym]

    Definition Classes
      PropositionalLogic

35. #### def gatherVariables(p: Prop): Set[Var]

    Definition Classes
      PropositionalLogic

36. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

37. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

38. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

39. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

40. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

42. #### def propToSolvable(p: Prop): Solvable

    Definition Classes
      PropositionalLogic

43. #### def removeVarEq(props: List[Prop], modelNull: Boolean = false): (Prop, List[Prop])

    Definition Classes
      PropositionalLogic

44. #### def simplify(f: Prop): Prop

    Simplifies propositional formula according to the following rules: - eliminate double negation (avoids unnecessary Tseitin variables) - flatten trees of same connectives (avoids unnecessary Tseitin variables) - removes constants and connectives that are in fact constant because of their operands - eliminates duplicate operands - convert formula into NNF: all sub-expressions have a positive polarity which makes them amenable for the subsequent Plaisted transformation and increases chances to figure out that the formula is already in CNF

    Simplifies propositional formula according to the following rules: - eliminate double negation (avoids unnecessary Tseitin variables) - flatten trees of same connectives (avoids unnecessary Tseitin variables) - removes constants and connectives that are in fact constant because of their operands - eliminates duplicate operands - convert formula into NNF: all sub-expressions have a positive polarity which makes them amenable for the subsequent Plaisted transformation and increases chances to figure out that the formula is already in CNF

    Complexity: DFS over formula tree

    See http://www.decision-procedures.org/slides/propositional_logic-2x3.pdf

    Definition Classes
      PropositionalLogic

45. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

46. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

47. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### def →[B](y: B): (Solver, B)

    Implicit information
      This member is added by an implicit conversion from Solver to ArrowAssoc[Solver] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from CNF

### Inherited from Solving.PropositionalLogic

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Solver to any2stringadd[Solver]

### Inherited by implicit conversion StringFormat from Solver to StringFormat[Solver]

### Inherited by implicit conversion Ensuring from Solver to Ensuring[Solver]

### Inherited by implicit conversion ArrowAssoc from Solver to ArrowAssoc[Solver]

### Ungrouped